<?php
/**
 * @connect_module_class_name CSpryPay
 *
 */
// SpryPay method implementation
// see also
//    http://www.sprypay.ru

class CSpryPay extends PaymentModule {

  var $type = PAYMTD_TYPE_ONLINE;
  var $default_logo = 'http://sprypay.ru/templates/users/images/sprypay.button.png';

  function _initVars(){
    $this->title    = CSPRYPAY_TTL;
    $this->description  = CSPRYPAY_DSCR;
    $this->sort_order   = 0;
    $this->Settings = array(
        "CONF_PAYMENTMODULE_SPRYPAY_SHOPID",
        "CONF_PAYMENTMODULE_SPRYPAY_SECRETKEY",
        "CONF_PAYMENTMODULE_SPRYPAY_ORDERSTATUS",
    );
  }

  function _initSettingFields(){

    $this->SettingsFields['CONF_PAYMENTMODULE_SPRYPAY_SHOPID'] = array(
      'settings_value'    => '',
      'settings_title'      => CSPRYPAY_SHOPID_TTL,
      'settings_description'  => CSPRYPAY_SHOPID_DSCR,
      'settings_html_function'  => 'setting_TEXT_BOX(0,',
      'sort_order'      => 1,
    );
    $this->SettingsFields['CONF_PAYMENTMODULE_SPRYPAY_SECRETKEY'] = array(
      'settings_value'    => '',
      'settings_title'      => CSPRYPAY_SECRETKEY_TTL,
      'settings_description'  => CSPRYPAY_SECRETKEY_DSCR,
      'settings_html_function'  => 'setting_TEXT_BOX(0,',
      'sort_order'      => 1,
    );



    $this->SettingsFields['CONF_PAYMENTMODULE_SPRYPAY_ORDERSTATUS'] = array(
      'settings_value'    => '-1',
      'settings_title'      => CSPRYPAY_ORDERSTATUS_TTL,
      'settings_description'  => CSPRYPAY_ORDERSTATUS_DSCR,
      'settings_html_function'  => 'setting_SELECT_BOX(CSPRYPay::_getStatuses(),',
      'sort_order'      => 1,
    );
  }
  static function _getStatuses(){

    $OStatuses = ostGetOrderStatues();
    $_OSt = array(
      ':-1'
      );
    $TC = count($OStatuses);
    for($_j = 0; $_j<$TC;$_j++){

      $_OSt[] = htmlspecialchars($OStatuses[$_j]['status_name']).':'.$OStatuses[$_j]['statusID'];
    }
    return implode(',',$_OSt);
  }

  function after_processing_html( $orderID )
  {
    $shop_id = $this->_getSettingValue('CONF_PAYMENTMODULE_SPRYPAY_SHOPID');

    $order = ordGetOrder($orderID);
    $amount = $order["order_amount"];
    if($order["currency_code"] == "RUB") $currency = "rur";
    else $currency = strtolower($order["currency_code"]);
   // $desc = str_replace(array('[order]'),array($orderID, CSPYPAY_PAYDESC));
   // $desc = $this->_getSettingValue('CONF_PAYMENTMODULE_SPRYPAY_DESC');//;str_replace("[orderID]",$orderID,$this->_getSettingValue('CONF_PAYMENTMODULE_SPRYPAY_DESC'));
    $email = $order["customer_email"];

    $res =
      "<table width='100%'>\n".
      " <tr>\n".
      "   <td align='center'>\n".
      "<form id='paymentform' method='POST' action='https://sprypay.ru/sppi/'>\n".
      " <input type='hidden' name='spShopId' value='".$shop_id."'>\n".
      " <input type='hidden' name='spShopPaymentId' value='".$orderID."'>\n".
      " <input type='hidden' name='spCurrency' value='".$currency."'>\n".
      " <input type='hidden' name='spPurpose' value='Order #".$orderID."'>\n".
      " <input type='hidden' name='spAmount' value='".$amount."'>\n".
      " <input type='hidden' name='spUserEmail' value='".$email."'>\n".
      " <input type='hidden' name='spIpnUrl' value='".$this->getDirectTransactionResultURL('success',array($orderID,$order['customer_email']))."'>\n".
      " <input type='hidden' name='spIpnMethod' value='1'>\n".
      " <input type='hidden' name='spSuccessUrl' value='".getTransactionResultURL('success')."'>\n".
      " <input type='hidden' name='spSuccessMethod' value='1'>\n".
      " <input type='hidden' name='spFailUrl' value='".getTransactionResultURL('failure')."'>\n".
      " <input type='hidden' name='spFailMethod' value='1'>\n".
      " <input type='hidden' name='lang' value='ru'>\n".
      " <input type='hidden' name='src' value='1'>\n".
      " <input type='submit' value='Оплатить заказ' align='center'>\n".
      "</form>\n".
      "   </td>\n".
      " </tr>\n".
      "</table>
      <script type='text/javascript'>document.getElementById('paymentform').submit();</script>";
    return $res;
  }

  function transactionResultHandler($transaction_result = '',$message = '',$source = 'frontend')
  {

      $spQueryFields = array('spPaymentId', 'spShopId', 'spShopPaymentId', 'spBalanceAmount', 'spAmount', 'spCurrency', 'spCustomerEmail', 'spPurpose', 'spPaymentSystemId', 'spPaymentSystemAmount', 'spPaymentSystemPaymentId', 'spEnrollDateTime', 'spHashString', 'spBalanceCurrency');
      foreach($spQueryFields as $spFieldName)
      if (!isset($_REQUEST[$spFieldName]))
      exit("error в запросе с данными платежа отсутствует параметр `$spFieldName`");

      $sign=md5($_REQUEST['spPaymentId'].$_REQUEST['spShopId'].$_REQUEST['spShopPaymentId'].
      			$_REQUEST['spBalanceAmount'].$_REQUEST['spAmount'].$_REQUEST['spCurrency'].
      			$_REQUEST['spCustomerEmail'].$_REQUEST['spPurpose'].$_REQUEST['spPaymentSystemId'].
      			$_REQUEST['spPaymentSystemAmount'].$_REQUEST['spPaymentSystemPaymentId'].$_REQUEST['spEnrollDateTime'].
      			$this->_getSettingValue('CONF_PAYMENTMODULE_SPRYPAY_SECRETKEY'));

      if ($sing == $REQUEST['spHashString'])
      {
		$orderID = $_REQUEST['spShopPaymentId'];
        $order = ordGetOrder($orderID);
        if (!$order)
            $error = 'error Unknow order ID';
      }
      else
        $error = 'error Security check failed';
      if ($error == '')
      {
         $statusID = $this->_getSettingValue('CONF_PAYMENTMODULE_SPRYPAY_ORDERSTATUS');
         $comment = 'Order #'.$_REQUEST['spShopPaymentId'].', SpryPay №'.$_REQUEST['spPaymentId'];
         ostSetOrderStatusToOrder($orderID, $statusID, $comment, 0, true);

        die('ok');
      }
      else
        die($error);

  }
}
?>